// ==============================================================
//                Engineering Unit Display
//          Copyright (C) 2004-2009 Chris Jeppesen,
//          St. Kwan's Home for the Terminally ADD
//                   All rights reserved
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of version 3.0 of the the GNU Lesser
// General Public License as published by the Free Software
// Foundation
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General
// Public License along with this library; if not, write to the
// Free Software Foundation, Inc., 51 Franklin Street, Fifth
// Floor, Boston, MA  02110-1301  USA
// ==============================================================

#include "orbitersdk.h"
#include "engunit.h"
#include <math.h>

int DisplayEngUnit(char* buffer, char* pattern,double x) {
  char Big[]=  " kMGTPEZY";
  char Small[]=" mnpfazy";
  int ptr=0;
  if(fabs(x)>1e-24) {
    if(fabs(x)>1) {
      while(fabs(x)>=1000 && ptr<=8) {
        ptr++;
        x=x/1000.0;
      }
      if(ptr==8) {
        ptr=8;
        x=999.999*((x>0)?1:-1);
      }
      return sprintf(buffer,pattern,x,Big[ptr]);
    } else {
      while(fabs(x)<1 && ptr<8) {
        ptr++;
        x=x*1000.0;
      }
      return sprintf(buffer,pattern,x,Small[ptr]);
    }
  } else {
    return sprintf(buffer,pattern,x,Small[0]);
  }
}

char* DisplayEngUnit2(char* buffer, char* pattern, char* SIUnit, char* USUnit, double USFactor, bool unit, double x) {
  //true on unit means use SI
  char Big[]=  " kMGTPEZY";
  char Small[]=" mnpfazy";
  int ptr=0;
  char* Unit;
  if(!unit) {
    Unit=USUnit;
    x*=USFactor;
  } else {
    Unit=SIUnit;
  }
  if(fabs(x)>1e-24) {
    if(fabs(x)>1) {
      while(fabs(x)>=1000 && ptr<=8) {
        ptr++;
        x=x/1000.0;
      }
      if(ptr==8) {
        ptr=8;
        x=999.999*((x>0)?1:-1);
      }
      sprintf(buffer,pattern,x,Big[ptr]);
      return strcat(buffer,Unit);
    } else {
      while(fabs(x)<1 && ptr<8) {
        ptr++;
        x=x*1000.0;
      }
      sprintf(buffer,pattern,x,Small[ptr]);
      return strcat(buffer,Unit);
    }
  } else {
    sprintf(buffer,pattern,x,Small[0]);
    return strcat(buffer,Unit);
  }
}

